

function radius = CalRadiusBits(ptn, w, bit)

[ptn_h ptn_w] = size(ptn);

ptn_1 = [ptn; -ones(1, ptn_w)];     % This means Xn = -1

wio = w(1:(end-1));

d = abs(w*ptn_1);

r = zeros(1,ptn_w);

    for k=1:ptn_w
        
        tmp_r = wio.*ptn(:,k)'*ptn(bit,k);
        sr = 2*sort(tmp_r);
        sr(1:end) = sr(end:-1:1); %descending order
        
        
        if( (w*ptn_1(:,k)*ptn(bit,k)) >=0 )
            r(k) = -2;
            for j=1:length(sr)
                if( sum(sr(1:j))>d(k) ) 
                    r(k) = j-1;
                end
            end
            if( r(k) == -2 )
                r(k) = length(sr);
            end
        else
            r(k) = -1;    
        end
    end


radius = min(r);
%radius = r;

% for i=1:ptn_w
%     figure(i);
%     subplot(3,1,2);
%     bar(r(:,i));
%     title(strcat('The Radius of each bit of Pattern ',char(i+64), ' (I)'));
%     axis([0 100 0 100]);
%     %xlabel('each bit(neuron)');
%     ylabel('Radius');
% end

end